LIST L=ON, P=16C84
;**************************************************************************
;               H L A S O T I V K A 
;		Selektivni volba pro mestskou policii Sternberk
;		Definovane cisla: 150 hasici
;				  155 sanitka
;				  156 mestska policie
;				  158 policie
;				  112 evropske er cislo	
;				  321 test
;		Alarmy: Po detekci cisla, se do eteru prehraje hlasova 
;		        zprava "Dovolali jste se na ..." a pote se rozsviti
;			prislusna LED poplachu a spusti se akusticky poplach
;			do stisku PTT.
;		Test: Pouze zapipa asi 10 tonu do eteru.
;		Upozorneni: Tento program je velice primitivni a urcite by
;			    se dal v mnoha vecech zoptimalizovat, ale byl
;			    jsem omezen casem, takze hlavi je, ze jede.		
;**************************************************************************
                include "PIC84HDR.EQU"		;vlozi include definice
;**************************************************************************
;**** PORT_A **************************************************************
		SPK		equ 1H		;vystup tonu pro speaker	
		MOD		equ 0H		;vystup tonu pro modulaci
		PTT		equ 2H		;vstup zaklicovani pull up
		STD		equ 3H		;STD vstup z CM8870
;**** PORT_B **************************************************************
		POZAR		equ 0H		;LED na pozarniky
		SANIT		equ 1H		;LED na sanitku
		MEPOL		equ 2H		;LED na mestskou polici
		POLIC		equ 3H		;LED na policii
		TX		equ 4H		;vystup vysilani TX-H
		JUMBO		equ 5H		;LED akt v L na det STD
		HLASKA		equ 6H		;vystup hlasky, akt v L
		ENAB		equ 7H		;volny vystup		
;**************************************************************************
; registers
;**************************************************************************			
		COUNT		equ 0CH				
		DELAY		equ 0DH
		ROGER		equ 0EH
		CNT1		equ 0FH
		CNT2		equ 10H
		NO3		equ 11H
		NO2		equ 12H	
		NO1		equ 13H
		TEMP		equ 14H
		COUN		equ 15H
		PAU		equ 16H
		NEWNUM		equ 17H
;**************************************************************************

		org Reset
		goto Start

;**************************************************************************
; HLAVNI PRODCEDURA
;**************************************************************************
MainLoop	btfss PORT_A,PTT	;test PTTkey na nulu 
		call OnAir
		btfsc PORT_A,STD	;test STD na jednicku
		call StdGoes
MainLoop2	btfsc PORT_A, STD
		goto MainLoop2
		movlw 0FFH
		subwf CNT2,W
		btfss SWR,Z
		call MainCNT	
		bsf PORT_B,JUMBO	;vypne zobrazeni STD impulsu
		bcf PORT_B,ENAB		;vypne LEDky
		goto MainLoop
MainCNT		incf CNT1		
		movlw 0FFH
		subwf CNT1,W
		btfss SWR,Z
		return
		clrf CNT1
		incf CNT2
		movlw 0FFH
		subwf CNT2,W
		btfss SWR,Z
		return
		movlw 0FFh
		movwf NO3
		movwf NO2
		movwf NO1
		return

;**************************************************************************
; PROCEDURY - AKTIVNI PO PRICHODU SIGNALU "STD" A POROVNANI CISEL
;**************************************************************************
StdGoes  	clrf CNT1
		clrf CNT2
		bcf PORT_B,JUMBO	;rozsviti LED prichu STD impulsu
		movfw PORT_B
		movwf NEWNUM
		bcf NEWNUM,4
		bcf NEWNUM,5
		bcf NEWNUM,6
		bcf NEWNUM,7
		movfw NO2
		movwf NO3
		movfw NO1
		movwf NO2
		movfw NEWNUM
		movwf NO1
StdWait		btfsc PORT_A,STD
		goto StdWait
Comp150		movlw b'00001000'	;1
		subwf NO3,W
		btfss SWR,Z
		goto Comp155
		movlw b'00001010'	;5
		subwf NO2,W
		btfss SWR,Z
		goto Comp155
		movlw b'00000101'	;0
		subwf NO1,W
		btfsc SWR,Z
		goto Poplach150
Comp155		movlw b'00001000'	;1
		subwf NO3,W
		btfss SWR,Z
		goto Comp156
		movlw b'00001010'	;5
		subwf NO2,W
		btfss SWR,Z
		goto Comp156
		movlw b'00001010'	;5
		subwf NO1,W
		btfsc SWR,Z
		goto Poplach155
Comp156		movlw b'00001000'	;1
		subwf NO3,W
		btfss SWR,Z
		goto Comp158
		movlw b'00001010'	;5
		subwf NO2,W
		btfss SWR,Z
		goto Comp158
		movlw b'00000110'	;6
		subwf NO1,W
		btfsc SWR,Z
		goto Poplach156
Comp158		movlw b'00001000'	;1
		subwf NO3,W
		btfss SWR,Z
		goto Comp112
		movlw b'00001010'	;5
		subwf NO2,W
		btfss SWR,Z
		goto Comp112
		movlw b'00000001'	;8
		subwf NO1,W
		btfsc SWR,Z
		goto Poplach158
Comp112		movlw b'00001000'	;1
		subwf NO3,W
		btfss SWR,Z
		goto CompTest
		movlw b'00001000'	;1
		subwf NO2,W
		btfss SWR,Z
		goto CompTest
		movlw b'00000100'	;2
		subwf NO1,W
		btfsc SWR,Z
		goto Poplach112
CompTest	movlw b'00001100'	;3
		subwf NO3,W
		btfss SWR,Z
		return
		movlw b'00000100'	;2
		subwf NO2,W
		btfss SWR,Z
		return
		movlw b'00001000'	;1
		subwf NO1,W
		btfsc SWR,Z
		call Delay1Sec
		bsf PORT_B,TX		;TEST zaklicuje
		movlw 0Ah
		movwf TEMP
TestLoop	call Delay1Sec		;pausa 1sec
		call Roger		;rogerbeep
		decfsz TEMP,f		
		goto TestLoop
		bcf PORT_B,TX
		return

;**************************************************************************
;ALARMY A POPLACHY
;**************************************************************************
Poplach150	movlw b'00000000'	;nastavi dolni 4bity PortB jako OUT 
		TRIS TRIS_B
		call Pryc
		bcf PORT_B,POZAR	;rozsviti LEDku pozarnici
		call Alarm		;spusti Alarm
		bsf PORT_B,POZAR	;zhasne LEDku pozarnici
		movlw b'00001111'	;nastavi dolni 4bity Port_B jako IN
		TRIS TRIS_B
		return
Poplach155	movlw b'00000000'	;nastavi dolni 4bity PortB jako OUT
		TRIS TRIS_B
		call Pryc
		bcf PORT_B,SANIT	;rozsviti LEDku santika
		call Alarm		;spusti Alarm
		bsf PORT_B,SANIT	;zhasne LEDku sanitka
		movlw b'00001111'	;nastavi dolni 4bity PortB jako IN
		TRIS TRIS_B
		return
Poplach156	movlw b'00000000'	;nastavi dolni 4bity PortB jako OUT
		TRIS TRIS_B
		call Pryc
		bcf PORT_B,MEPOL	;rozsviti LEDku mestska policie
		call Alarm		;spusti Alarm
		bsf PORT_B,MEPOL	;zhasne LEDku mestska policie
		movlw b'00001111'	;nastavi dolni 4bity PortB jako IN
		TRIS TRIS_B
		return
Poplach158	movlw b'00000000'	;nastavi dolni 4bity PortB jako OUT
		TRIS TRIS_B
		call Pryc
		bcf PORT_B,POLIC	;rozsviti LEDku policie
		call Alarm		;spusti Alarm
		bsf PORT_B,POLIC	;zhasne LEDku policie
		movlw b'00001111'	;nastavi dolni 4bity PortB jako IN
		TRIS TRIS_B
		return
Poplach112	movlw b'00000000'	;nastavi dolni 4bity PortB jako OUT
		TRIS TRIS_B
		bcf PORT_B,POZAR	;rozsviti LEDku pozarnici
		bcf PORT_B,SANIT	;rozsviti LEDku sanitka
		bcf PORT_B,MEPOL	;rozsviti LEDku mestska policie
		bcf PORT_B,POLIC	;rozsviti LEDku policie
		call Alarm		;spusti Alarm
		bsf PORT_B,POZAR	;zhasne LEDku pozarnici
		bsf PORT_B,SANIT	;zhasne LEDku sanitka
		bsf PORT_B,MEPOL	;zhasne LEDku mestska policie
		bsf PORT_B,POLIC	;zhasne LEDku policie
		movlw b'00001111'	;nastavi dolni 4bity PortB jako IN
		TRIS TRIS_B
		return
Alarm		call Delay1Sec
		bsf PORT_B,TX		;zaklicuje
		call Delay1Sec		;pausa 1 sekunda
		call Roger		;pipne
		bcf PORT_B,HLASKA	;zapne hlasku		
		movlw 13H				
		movwf TEMP	
AlarmLoop	call Delay1Sec		;cekani 12sec na play hlasky
		btfss PORT_A,PTT	;jestlize se stisk. PTT, tak
		goto AlarmRet		;to jde na AlarmRet
		decfsz TEMP,f		
		goto AlarmLoop
		call AlarmRet		;zavola ukonceni hlasky
		call Roger
 		bcf PORT_B,TX		;odklicuje
AlarmLoop2	call Buzz		;akusticka indikace
		bsf PORT_B,ENAB
		btfss PORT_A,PTT	;test PTT
		return
		call UnBuzz		;Pauza ve smycce
		btfss PORT_A,PTT	;test PTT
		return
		bcf PORT_B,ENAB
		goto AlarmLoop2
AlarmRet	bsf PORT_B,HLASKA	;vypne hlasku
		return

Buzz		movlw 0FFH		;beep na speaker
		movwf ROGER	
BuzzLoop	bsf PORT_A,SPK		;H na speaker
		call Pause		;pausa
		bcf PORT_A,SPK		;L na speaker
		call Pause		;pausa
		btfss PORT_A,PTT	;test PTT, pak return
		return	
		decfsz ROGER,f
		goto BuzzLoop
		return

UnBuzz		movlw 0FFH
		movwf ROGER	
UnBuzzLoop	call Pause		;pausa
		call Pause		;pausa
		btfss PORT_A,PTT	;test PTT, pak return
		return
		decfsz ROGER,f
		goto UnBuzzLoop
		return

Pryc		bsf PORT_B,POZAR
		bsf PORT_B,SANIT
		bsf PORT_B,MEPOL
		bsf PORT_B,POLIC
		return
;**************************************************************************
; POMOCNE PROCEDURY
;**************************************************************************
Delay1Sec 	movlw 0FFh
		movwf COUNT
DelayLoop	call Pause
		call Pause
		call Pause
		call Pause
		call Pause
		decfsz COUNT,f
		goto DelayLoop
		return

Delay10ms 	movlw 1Fh
		movwf COUN
Del10Loop	call Pause
		decfsz COUN,f
		goto Del10Loop
		return

Pause 		movlw 080h
		movwf PAU
PauseLoop	decfsz PAU,f
		goto PauseLoop
		return
;*********************************************************************
;VYSILANI
;*********************************************************************
OnAir		call Delay10ms		;osetri vstup PTT
		btfsc PORT_A,PTT
		return
		bcf PORT_A,MOD		;nastavi L do modulace
		bcf PORT_A,SPK		;nastavi L do speakeru
		bsf PORT_B,TX		;zaklicuje stanici
OnAirLoop	bsf PORT_B,JUMBO
		btfss PORT_A,PTT	;test odklicovani
		goto OnAirLoop
		call Delay10ms		
		btfss PORT_A,PTT
		goto OnAirLoop
		call Roger
		bcf PORT_B,TX
		return

Roger		movlw 0AFH		;rogerbeep
		movwf ROGER	
RogerLoop	bsf PORT_A,MOD		;H na modulaci
		call Pause		;pausa
		bcf PORT_A,MOD		;L na modulaci
		call Pause		;pausa
		decfsz ROGER,f
		goto RogerLoop
		return
;**********************************************************************
;START
;**********************************************************************
Start		movlw b'00001100'	;4 a 3 jako IN - STD a PTT
		TRIS TRIS_A
		movlw b'00001111'
		TRIS TRIS_B
		clrf PORT_A
		clrf PORT_B
		clrf INTCON
		clrf CNT1
		clrf CNT2
		clrf NO1
		clrf NO2	
		clrf NO3
		bsf PORT_B,HLASKA	;nastavi bit HLASKA do H 
		bsf PORT_B,JUMBO	;zhasne LEDku indikace STD
		bsf PORT_B,POZAR	;zhasne LEDku pozarniku
		bsf PORT_B,SANIT	;zhasne LEDku sanitky
		bsf PORT_B,MEPOL	;zhasne LEDku mestske policie
		bsf PORT_B,POLIC	;zhasne LEDku policie
 		goto MainLoop
	
  		end